package com.azwul.api.service;

import java.io.File;

import com.azwul.api.model.SessionToken;
import com.azwul.api.model.result.ClicInitResult;
import com.azwul.api.model.result.ClicLoginResult;
import com.azwul.api.model.result.SignatureResult;

public interface AzClicService extends AzBaseService {

	/**
	 * @param token
	 * @param secret
	 * @param email
	 * @param documentUrl
	 * @param callbackUrl
	 * @return
	 */
	public ClicInitResult doInit(String token, String secret, String email,
			String documentUrl, String callbackUrl);

	/**
	 * @param token
	 * @param secret
	 * @param email
	 * @param documentUrl
	 * @param signatureFormat
	 * @param callbackUrl
	 * @param responseFormat
	 * @return
	 */
	public ClicInitResult doInit(String token, String secret, String email,
			String documentUrl, String signatureFormat, String callbackUrl,
			String responseFormat);

	/**
	 * @param sessionId
	 * @param keystore
	 * @param password
	 * @return
	 */
	public ClicLoginResult doLogin(String sessionId, File keystore,
			String password);

	/**
	 * @param secret
	 * @param sessionToken
	 * @return
	 */
	public SignatureResult doSign(String secret, SessionToken sessionToken);

}
